﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Trinity.Framework.Objects.Enums
{
    /// <summary>
    /// Extracted from ItemTypeName stringlist; values are GameBalanceName as DB's version of GameBalanceId 
    /// </summary>
    public enum RawItemType
    {
        // Manually Added:
        ProgressionOrb = 126166628,
        UberReagent = -49494186,
        // Generated from:
        // * ItemHash on x000_Text of "ItemTypes" / 19755 / ItemTypes.gam
        // * ItemHash on GameBalanceName of "ItemTypeNames" / 52009 / ItemTypeNames.stl
        GenericRangedWeapon = 165564792,
        BeltCrusader = -1029603201,
        BeltDemonHunter = 9087215,
        BeltMonk = 1555631483,
        BeltWitchDoctor = 994235600,
        GenericOffHand = 344906995,
        OffhandOther = -720431272,
        TieredRiftKey = -137533477,
        ChaosShard = -592249216,
        ScrollSpectralHound = -2116645237,
        ScrollAngelWings = 1582842526,
        HealthGlyph = 1883419642,
        ShrineGlyph = 1509903661,
        QuestUsable = -938309842,
        KnowledgeUtility = 167097204,
        NephalemCube = -1352920439,
        TalismanUnlock = 1626390053,
        StoneOfWealth = -1812121245,
        StoneOfRecall = -2007738575,
        CursedHoradricReagent = 1036502744,
        CollectibleDevilsHand = 1910607907,
        TreasureBag = 1650316949, // All Caches >> HoradricCacheBonusAct // HoradricCacheA1
        BloodShard = 1932948546,
        Platinum = -1055802742,
        Mace = 4026134,
        Weapon = 485534122,
        Melee = 133016072,
        Swing = 140775496,
        Axe = 109694,
        Axe2H = 119458520,
        Club = 3679334,
        Sword = 140782159,
        Sword2H = -1307049751,
        Hammer = -105812806,
        Hammer2H = 733973012,
        Mace2H = 89494384,
        FistWeapon = -2094596416,
        CombatStaff = -1620551894,
        Thrust = 372302218,
        Dagger = -262576534,
        Polearm = -1203595600,
        Ranged = 285570513,
        BowClass = -293202082,
        Bow = 110504,
        StarterBow = -351493670,
        Crossbow = -1338851342,
        MagicClass = 1794196247,
        Wand = 4385866,
        Staff = 140658708,
        Thrown = 372295810,
        ThrowingAxe = 662916496,
        Spear = 140519163,
        Armor = 119253633,
        Shield = 332825721,
        Helm = 3851110,
        Gloves = -131821392,
        Boots = 120334087,
        Shoulders = -940830407,
        ChestArmor = -1028103400,
        GenericBelt = -948083356,
        Legs = 3994699,
        Other = 135922626,
        Scroll = 327230447,
        TownPortalStone = -797314365,
        ScrollIdentify = -1266506293,
        ScrollDispelCurse = 218258642,
        ScrollReverseCurse = 1837549997,
        Potion = 224120761,
        HealthPotion = -1916071921,
        ManaPotion = -1742935562,
        RejuvenationPotion = 25536371,
        AntidotePotion = -8879823,
        Jewelry = -740765630,
        Ring = 4214896,
        Amulet = -365243096,
        Charm = 121253131,
        Enchantment = -1797970955,
        Socketable = -792466723,
        Rune = 4227962,
        Gem = 115609,
        Bloodstone = 1933394905,
        Coral = 121522641,
        Moonstone = 1929493634,
        Opal = 4114284,
        Amber = 119061639,
        Jade = 3918356,
        Jet = 118883,
        Skull = 140357259,
        Amethyst = 1065665231,
        Diamond = 231103068,
        Pearl = 136562292,
        Carnelian = -528969939,
        Hematite = 1591177969,
        Pyrite = 235908253,
        Emerald = 1684020666,
        Garnet = -144767423,
        Lapis = 131690905,
        Malachite = -2130830232,
        Onyx = 4112910,
        Quartz = 269698855,
        Ruby = 4227586,
        Sapphire = 1506474556,
        Topaz = 141681134,
        Quest = 138327602,
        Gold = 3826054,
        All = 109305,
        Quiver = 269990204,
        Orb = 124739,
        ScrollOfPower = -527849711,
        ProtectionScroll = -885172778,
        DetectionScroll = 898794126,
        InvisibilityPotion = -293992936,
        HearthScroll = 1322977867,
        ElixirOfStrength = -360296335,
        ElixirOfDexterity = -2140663004,
        ElixirOfVitality = 1693192664,
        ElixirOfWillpower = 688737703,
        ElixirOfRegeneration = -1602692251,
        ElixirOfSuperiority = -1540093551,
        VialOfResurrection = -1279684730,
        ScrollWealth = 555660404,
        RunestoneA = 715453891,
        RunestoneB = 715453892,
        RunestoneC = 715453893,
        RunestoneD = 715453894,
        RunestoneE = 715453895,
        Dye = 112994,
        ScrollDisenchant = 979329008,
        ScrollCalling = 953860425,
        ScrollGreed = 1169689462,
        ScrollCompanion = 468192851,
        ScrollReforgeA = 1379106330,
        ScrollReforgeB = 1379106331,
        ScrollReforgeC = 1379106332,
        TemplarSpecial = 129668150,
        ScoundrelSpecial = -953512528,
        EnchantressSpecial = -464307745,
        CraftingReagent = -2019730316,
        Bracers = -1999984446,
        HandXbow = 763102523,
        PageOfKnowledge = 1132285266,
        Cloak = 121411562,
        CeremonialDagger = -199811863,
        MightyWeapon1H = -1488678091,
        SpiritStoneMonk = 576647032,
        WizardHat = -1499089042,
        VoodooMask = -333341566,
        BeltBarbarian = -479768568,
        Mojo = 4041621,
        MightyWeapon2H = -1488678058,
        PowerPotion = -910124122,
        ProtectionPotion = -988282464,
        PageOfRespec = -1249722316,
        RespecTome = -2085326953,
        TomeOfKnowledge = -363305942,
        GenericHelm = -947867741,
        GenericBowWeapon = 395678127,
        GenericThrustWeapon = 998499313,
        GenericSwingWeapon = 1846932879,
        GenericChestArmor = 828360981,
        CraftingPlan = -342766503,
        CraftingPlanSmith = -1515023331,
        CraftingPlanJeweler = 371712870,
        Elixir = -210305491,
        CraftingPlanLegendarySmith = -1669219336,
        Belt = 3635495,
        CrusaderShield = 602099538,
        Flail1H = -1363671135,
        Flail2H = -1363671102,
        PageOfTrainingJeweler = -1621997189,
        PageOfTrainingSmith = -1083019022,
        TrainingTome = -5794479,
        DemonicKey = -1979915768,
        CraftingPlanMystic = 1323615825,
        ScrollBuff = 1987526610,
        ScrollEnchant = -260236560,
        ScrollProc = 1988026755,
        CraftingReagentBound = -1118030101,
        Jewel = 129470295,
        PortalDevice = -1041196094,
        Shard = 140227858,
        GreaterShard = 1331402556,
        CraftingPlanMysticTransmog = 1295639964,
        MysteryWeapon1H = -241705760,
        MysteryWeapon2H = -241705727,
        HelmWizard = 813646326,
        HelmBarbarian = -1587563257,
        HelmDemonHunter = 506481070,
        HelmWitchDoctor = 1491629455,
        HelmMonk = 122656538,
        HelmCrusader = -2104376930,
        ChestArmorBarbarian = -1289348295,
        ChestArmorDemonHunter = -1154939808,
        ChestArmorMonk = 1667159564,
        ChestArmorWizard = -849738392,
        ChestArmorCrusader = -1054135920,
        ChestArmorWitchDoctor = -169791423,
        ShouldersBarbarian = 1212065434,
        ShouldersDemonHunter = -124654591,
        ShouldersMonk = -821460787,
        ShouldersCrusader = 62868689,
        ShouldersWizard = -832936855,
        ShouldersWitchDoctor = 860493794,
        LegsBarbarian = -1177810900,
        LegsCrusader = 1031652387,
        LegsDemonHunter = 50199059,
        LegsWizard = -1995514053,
        LegsWitchDoctor = 1035347444,
        LegsMonk = 1717378847,
        BootsBarbarian = -2097752600,
        BootsCrusader = -1989686689,
        BootsDemonHunter = -1038932273,
        BootsMonk = 1931831131,
        BootsWizard = -385210761,
        BootsWitchDoctor = -53783888,
        GlovesBarbarian = 444212945,
        GlovesDemonHunter = 1202607608,
        GlovesMonk = 922698404,
        GlovesWizard = 180877312,
        GlovesWitchDoctor = -2107211303,
        GlovesCrusader = 299901480,
        UpgradeableJewel = 1888008307,
        RamaladnisGift = -1380314094,
        HoradricReagent = 770629778,
    }

}
