namespace Trinity.Framework.Objects.Memory.Misc
{
    public enum ErrorResultType // 2.4.0.36090 @26703568 index:52
    {
        PowerUnusableInArea = 0,
        ItemNotReady = 1,
        PowerInvalidTarget = 2,
        PowerNotEnoughHealth = 3,
        PowerNotEnoughCharges = 4,
        PowerNotEnoughMana = 5,
        PowerNotEnoughArcanum = 6,
        PowerNotEnoughFury = 7,
        PowerNotEnoughSpirit = 8,
        PowerNotEnoughHatred = 9,
        PowerNotEnoughDiscipline = 10,
        PowerNotEnoughFaith = 11,
        PowerWrongWeapon = 12,
        PowerInTown = 13,
        PowerTargetTooFar = 14,
        PowerInCooldown = 15,
        PowerNeedsLineOfSight = 16,
        PowerUnusableInCombat = 17,
        PowerUnusableGeneric = 18,
        PowerUnusableWhileMoving = 19,
        PowerMissingItem = 20,
        PowerUnusableDuringBossEncounter = 21,
        IarNotAllowedHere = 22,
        IarCantTradeQuestItems = 23,
        IarCantEquipUnidentifiedItem = 24,
        IarPlayerDoesntMeetItemRequirements = 25,
        IarPlayerDoesntMeetItemLevel = 26,
        IarPlayerIsWrongClassForItem = 27,
        IarTemplarCannotUseWeapon = 28,
        IarScoundrelCannotUseWeapon = 29,
        IarEnchantressCannotUseWeapon = 30,
        IarTemplarCannotEquipSpecialItem = 31,
        IarScoundrelCannotEquipSpecialItem = 32,
        IarEnchantressCannotEquipSpecialItem = 33,
        IarHirelingCantUseItem = 34,
        IarHirelingDoesntMeetItemLevel = 35,
        IarItemTypeDoesntMatchSlot = 36,
        IarNotEnoughRoom = 37,
        IarContainerRemoveOnly = 38,
        IarNoFreeSockets = 39,
        IarItemIsSeasonal = 40,
        IarItemIsNonSeasonal = 41,
        IarItemRequiresSkill = 42,
        IarItemRequiresXBow = 43,
        ItemCraftingNoCombineDesign = 44,
        ItemCraftingMissingReagents = 45,
        IarCannotSalvage = 46,
        IarCannotSalvageGemmedItems = 47,
        IarCannotSalvageVendorItems = 48,
        SkillsSkillbarGeneric = 49,
        SkillsNotAssignableToThatSlot = 50,
        SkillsCantChangeWhileInCooldown = 51,
        SkillsCantChangeWhileInCombat = 52,
        SkillsCantChangeWhileInBossEncounter = 53,
        SkillsCantChangeAtThisTime = 54,
        BuffHigherLevelActive = 55,
        AlreadyIdentified = 56,
        CannotSocket = 57,
        AlreadySocketed = 58,
        CannotUnSocket = 59,
        CannotSocketWithThisItem = 60,
        CannotAcceptTrade = 61,
        CannotTrade = 62,
        CannotTradeBecauseOfGems = 63,
        ItemUseUnknown = 64,
        ItemUseNotOnUnidentifiedItems = 65,
        ItemUseAlreadyAtMaxHealth = 66,
        ItemUseRecipeAlreadyKnown = 67,
        ItemUseOnlyAtBlacksmith = 68,
        ItemUseOnlyAtJeweler = 69,
        ItemUseOnlyAtMystic = 70,
        ItemUseDoesntMeetArtisanLevel = 71,
        ItemUseNotEnoughPagesToConvert = 72,
        CannotDoWhileDead = 73,
        SomeoneDeclined = 74,
        PickupFailed = 75,
        PickupNoSuitableSlot = 76,
        PickupOnlyOneAllowed = 77,
        PickupBelongsToOther = 78,
        InsufficientFunds = 79,
        InsufficientFundsSpecialCurrency = 80,
        InsufficientFundsPlatinum = 81,
        InsufficientParagonPoints = 82,
        ParagonCategoryMaxed = 83,
        ItemCannotBeRepaired = 84,
        ItemCannotBeEnchanted = 85,
        ItemCannotBeEnchantedByType = 86,
        ItemCannotBeEnchantedBelowItemLevel = 87,
        ItemCannotBeEnchantedAboveItemLevel = 88,
        ItemCannotBeEnchantedUnidentified = 89,
        ItemCannotBeEnchantedSocketable = 90,
        ItemCannotBeEnchantedInvalidQuality = 91,
        ItemCannotBeEnchantedFilledSockets = 92,
        ItemCannotBeEnchantedCrafted = 93,
        ItemCannotBeEnchantedNoRandomAffixes = 94,
        ItemCannotBeEnchantedLegacy = 95,
        ItemCannotBeEnchantedMysticLevelRequired = 96,
        ItemCannotBeImproved = 97,
        ItemCannotBeDyed = 98,
        ItemCannotBeReforged = 99,
        ItemCannotBeReforgedUnidentified = 100,
        ItemCannotBeReforgedNotLegendary = 101,
        ItemCannotBeReforgedCannotEquip = 102,
        ItemCannotBeReforgedHasGems = 103,
        ItemCannotBeUsedForTransmog = 104,
        ItemCannotBeUsedForTransmogUnidentified = 105,
        ItemTransmogAlreadyUnlocked = 106,
        TradeOtherBusy = 107,
        TradeSplitStacks = 108,
        TradeDisabled = 109,
        TradeOfGoldDisabled = 110,
        NoOtherWaypoints = 111,
        BnetPartyLeaderCancelLeaveGame = 112,
        BnetPartyInviteRemovedLeaveGameCanceled = 113,
        BnetMultiplayerGameNotPaused = 114,
        BnetNoSeasonJourneyAvailableInNoSeasonalGame = 115,
        CannotDoDuringBossEncounter = 116,
        CannotDoDuringQueuedBossEncounter = 117,
        BannerPlayerTooClose = 118,
        BannerPlayerIsInBossEncounter = 119,
        BannerPlayerIsDead = 120,
        PlayerIsDueling = 121,
        CannotKickNow = 122,
        ItemSoldNonError = 123,
        ItemCannotBeSold = 124,
        ItemIsUniqueEquipped = 125,
        CannotDoThatRightNow = 126,
        ItemSocketTypeMismatch = 127,
        ItemSocketUniqueEquipped = 128,
        EquipItemSocketUniqueEquipped = 129,
        IdentifyAllNoItems = 130,
        ItemCannotBeDropped = 131,
        WaypointTooClose = 132,
        NephalemRiftWarningPartyInside = 133,
        BannerPlayerIsInTieredLootRun = 134,
        NephalemRiftWarningPlayerNeedsKey = 135,
        NephalemRiftWarningPlayerNeedsTieredKey = 136,
        NephalemRiftWarningPlayerDeclined = 137,
        NephalemRiftWarningTieredRiftAlreadyStarted = 138,
        NephalemRiftWarningTieredRiftNotMaxLevel = 139,
        NephalemRiftWarningTieredRiftGameNotMaxLevel = 140,
        NephalemRiftWarningCantDoThatDuringTieredRift = 141,
        NephalemRiftWarningCantChangeSkillsOrEquipmentOutsideGame = 142,
        CannotDoThatRightNow2 = 143,
        DifficultyTooLow = 144,
        ItemsCannotBeMovedAtThisTime = 145,
        PlayerNotAllowedInWorld = 146,
        TransmuteCannotUseItemWithFilledSockets = 147,
        TransmuteCannotUseUnidentifiedItem = 148,
        TransmuteMissingCoreIngredients = 149,
        TransmuteCannotUseThisItem = 150,
        TransmuteFailed = 151,
        TransmuteFailedLegendaryPowerAlreadyExtracted = 152,
        TransmuteFailedLegendaryPowerUnavailable = 153,
        TransmuteFailedCannotExtractFromThisItem = 154,
        TransmuteFailedCannotUseCraftedItem = 155,
        TransmuteFailedCannotEquipItem = 156,
        TransmuteFailedCannotFindItem = 157,
        TransmuteFailedItemLevelTooLow = 158,
        TransmuteFailedAlreadyRemovedLevelReq = 159,
        TransmuteFailedNotEnoughItemsInSet = 160,
        EmpoweredRiftCannotAfford = 161,
        BannerPlayerIsInSetDungeon = 162,
        TransmuteFailedLowJewelRank = 163,
        SetDungeonCancelled = 164,
        SetDungeonCannotEnterNotWorthy = 165,
        SetDungeonCannotEnterClosing = 166,
    }
}