﻿using System.Collections.Generic;
using Zeta.Game.Internals.Actors;

namespace Trinity.ItemRules.Core
{

    public class MaxStats
    {
        public static Dictionary<string, double> maxItemStats = new Dictionary<string, double>();

        static MaxStats()
        {
            buildMaxItemStats();
        }

        static void buildMaxItemStats()
        {
            ItemType[] oneHandWeapons = new ItemType[] {
                ItemType.Axe,
                ItemType.CeremonialDagger,
                ItemType.Dagger,
                ItemType.FistWeapon,
                ItemType.HandCrossbow,
                ItemType.Mace,
                ItemType.MightyWeapon,
                ItemType.Spear,
                ItemType.Sword,
                ItemType.Wand
            };

            ItemType[] twoHandMeleeWeapons = new ItemType[] {
                ItemType.Axe,
                ItemType.Daibo,
                ItemType.Polearm,
                ItemType.Mace,
                ItemType.MightyWeapon,
                ItemType.Staff,
                ItemType.Sword
            };
            ItemType[] twoHandRangeWeapons = new ItemType[] {
                ItemType.Bow,
                ItemType.Crossbow,
            };

            maxItemStats.Add("SpiritStoneFalse[DEX]", 200);
            maxItemStats.Add("SpiritStoneFalse[INT]", 300);
            maxItemStats.Add("SpiritStoneFalse[STR]", 200);
            maxItemStats.Add("SpiritStoneFalse[VIT]", 200);
            maxItemStats.Add("SpiritStoneFalse[AS%]", -1);
            maxItemStats.Add("SpiritStoneFalse[CRIT%]", 6);
            maxItemStats.Add("SpiritStoneFalse[CRITDMG%]", -1);
            maxItemStats.Add("SpiritStoneFalse[MAXDMG]", -1);
            maxItemStats.Add("SpiritStoneFalse[MINDMG]", -1);
            maxItemStats.Add("SpiritStoneFalse[BLOCK%]", -1);
            maxItemStats.Add("SpiritStoneFalse[ARMORBONUS]", 397);
            maxItemStats.Add("SpiritStoneFalse[THORNS]", 1454);
            maxItemStats.Add("SpiritStoneFalse[RESARCAN]", 60);
            maxItemStats.Add("SpiritStoneFalse[RESCOLD]", 60);
            maxItemStats.Add("SpiritStoneFalse[RESFIRE]", 60);
            maxItemStats.Add("SpiritStoneFalse[RESHOLY]", 60);
            maxItemStats.Add("SpiritStoneFalse[RESLIGHTNING]", 60);
            maxItemStats.Add("SpiritStoneFalse[RESPHYSICAL]", 60);
            maxItemStats.Add("SpiritStoneFalse[RESPOISON]", 60);
            maxItemStats.Add("SpiritStoneFalse[ALLRES]", 80);
            maxItemStats.Add("SpiritStoneFalse[GLOBEBONUS]", 12794);
            maxItemStats.Add("SpiritStoneFalse[LIFE%]", 0.12);
            maxItemStats.Add("SpiritStoneFalse[LOH]", -1);
            maxItemStats.Add("SpiritStoneFalse[REGEN]", 342);
            maxItemStats.Add("SpiritStoneFalse[LS%]", -1);
            maxItemStats.Add("SpiritStoneFalse[GF%]", 0.25);
            maxItemStats.Add("SpiritStoneFalse[MF%]", 0.2);
            maxItemStats.Add("SpiritStoneFalse[MS%]", -1);
            maxItemStats.Add("SpiritStoneFalse[PICKRAD]", 7);
            maxItemStats.Add("SpiritStoneFalse[SOCKETS]", 1);
            maxItemStats.Add("SpiritStoneFalse[MAXFURY]", -1);
            maxItemStats.Add("SpiritStoneFalse[HATREDREG]", -1);
            maxItemStats.Add("SpiritStoneFalse[MAXDISCIP]", -1);
            maxItemStats.Add("SpiritStoneFalse[HEALTHSPIRIT]", 30);
            maxItemStats.Add("SpiritStoneFalse[SPIRITREG]", 2.5);
            maxItemStats.Add("SpiritStoneFalse[MANAREG]", -1);
            maxItemStats.Add("SpiritStoneFalse[MAXMANA]", -1);
            maxItemStats.Add("SpiritStoneFalse[ARCONCRIT]", -1);
            maxItemStats.Add("SpiritStoneFalse[MAXARCPOWER]", -1);
            maxItemStats.Add("VoodooMaskFalse[DEX]", 200);
            maxItemStats.Add("VoodooMaskFalse[INT]", 300);
            maxItemStats.Add("VoodooMaskFalse[STR]", 200);
            maxItemStats.Add("VoodooMaskFalse[VIT]", 200);
            maxItemStats.Add("VoodooMaskFalse[AS%]", -1);
            maxItemStats.Add("VoodooMaskFalse[CRIT%]", 6);
            maxItemStats.Add("VoodooMaskFalse[CRITDMG%]", -1);
            maxItemStats.Add("VoodooMaskFalse[MAXDMG]", -1);
            maxItemStats.Add("VoodooMaskFalse[MINDMG]", -1);
            maxItemStats.Add("VoodooMaskFalse[BLOCK%]", -1);
            maxItemStats.Add("VoodooMaskFalse[ARMORBONUS]", 397);
            maxItemStats.Add("VoodooMaskFalse[THORNS]", 1454);
            maxItemStats.Add("VoodooMaskFalse[RESARCAN]", 60);
            maxItemStats.Add("VoodooMaskFalse[RESCOLD]", 60);
            maxItemStats.Add("VoodooMaskFalse[RESFIRE]", 60);
            maxItemStats.Add("VoodooMaskFalse[RESHOLY]", 60);
            maxItemStats.Add("VoodooMaskFalse[RESLIGHTNING]", 60);
            maxItemStats.Add("VoodooMaskFalse[RESPHYSICAL]", 60);
            maxItemStats.Add("VoodooMaskFalse[RESPOISON]", 60);
            maxItemStats.Add("VoodooMaskFalse[ALLRES]", 80);
            maxItemStats.Add("VoodooMaskFalse[GLOBEBONUS]", 12794);
            maxItemStats.Add("VoodooMaskFalse[LIFE%]", 0.12);
            maxItemStats.Add("VoodooMaskFalse[LOH]", -1);
            maxItemStats.Add("VoodooMaskFalse[REGEN]", 342);
            maxItemStats.Add("VoodooMaskFalse[LS%]", -1);
            maxItemStats.Add("VoodooMaskFalse[GF%]", 0.25);
            maxItemStats.Add("VoodooMaskFalse[MF%]", 0.2);
            maxItemStats.Add("VoodooMaskFalse[MS%]", -1);
            maxItemStats.Add("VoodooMaskFalse[PICKRAD]", 7);
            maxItemStats.Add("VoodooMaskFalse[SOCKETS]", 1);
            maxItemStats.Add("VoodooMaskFalse[MAXFURY]", -1);
            maxItemStats.Add("VoodooMaskFalse[HATREDREG]", -1);
            maxItemStats.Add("VoodooMaskFalse[MAXDISCIP]", -1);
            maxItemStats.Add("VoodooMaskFalse[HEALTHSPIRIT]", -1);
            maxItemStats.Add("VoodooMaskFalse[SPIRITREG]", -1);
            maxItemStats.Add("VoodooMaskFalse[MANAREG]", 14);
            maxItemStats.Add("VoodooMaskFalse[MAXMANA]", 150);
            maxItemStats.Add("VoodooMaskFalse[ARCONCRIT]", -1);
            maxItemStats.Add("VoodooMaskFalse[MAXARCPOWER]", -1);
            maxItemStats.Add("WizardHatFalse[DEX]", 200);
            maxItemStats.Add("WizardHatFalse[INT]", 300);
            maxItemStats.Add("WizardHatFalse[STR]", 200);
            maxItemStats.Add("WizardHatFalse[VIT]", 200);
            maxItemStats.Add("WizardHatFalse[AS%]", -1);
            maxItemStats.Add("WizardHatFalse[CRIT%]", 6);
            maxItemStats.Add("WizardHatFalse[CRITDMG%]", -1);
            maxItemStats.Add("WizardHatFalse[MAXDMG]", -1);
            maxItemStats.Add("WizardHatFalse[MINDMG]", -1);
            maxItemStats.Add("WizardHatFalse[BLOCK%]", -1);
            maxItemStats.Add("WizardHatFalse[ARMORBONUS]", 397);
            maxItemStats.Add("WizardHatFalse[THORNS]", 1454);
            maxItemStats.Add("WizardHatFalse[RESARCAN]", 60);
            maxItemStats.Add("WizardHatFalse[RESCOLD]", 60);
            maxItemStats.Add("WizardHatFalse[RESFIRE]", 60);
            maxItemStats.Add("WizardHatFalse[RESHOLY]", 60);
            maxItemStats.Add("WizardHatFalse[RESLIGHTNING]", 60);
            maxItemStats.Add("WizardHatFalse[RESPHYSICAL]", 60);
            maxItemStats.Add("WizardHatFalse[RESPOISON]", 60);
            maxItemStats.Add("WizardHatFalse[ALLRES]", 80);
            maxItemStats.Add("WizardHatFalse[GLOBEBONUS]", 12794);
            maxItemStats.Add("WizardHatFalse[LIFE%]", 0.12);
            maxItemStats.Add("WizardHatFalse[LOH]", -1);
            maxItemStats.Add("WizardHatFalse[REGEN]", 342);
            maxItemStats.Add("WizardHatFalse[LS%]", -1);
            maxItemStats.Add("WizardHatFalse[GF%]", 0.25);
            maxItemStats.Add("WizardHatFalse[MF%]", 0.2);
            maxItemStats.Add("WizardHatFalse[MS%]", -1);
            maxItemStats.Add("WizardHatFalse[PICKRAD]", 7);
            maxItemStats.Add("WizardHatFalse[SOCKETS]", 1);
            maxItemStats.Add("WizardHatFalse[MAXFURY]", -1);
            maxItemStats.Add("WizardHatFalse[HATREDREG]", -1);
            maxItemStats.Add("WizardHatFalse[MAXDISCIP]", -1);
            maxItemStats.Add("WizardHatFalse[HEALTHSPIRIT]", -1);
            maxItemStats.Add("WizardHatFalse[SPIRITREG]", -1);
            maxItemStats.Add("WizardHatFalse[MANAREG]", -1);
            maxItemStats.Add("WizardHatFalse[MAXMANA]", -1);
            maxItemStats.Add("WizardHatFalse[ARCONCRIT]", 10);
            maxItemStats.Add("WizardHatFalse[MAXARCPOWER]", 15);
            maxItemStats.Add("HelmFalse[DEX]", 200);
            maxItemStats.Add("HelmFalse[INT]", 300);
            maxItemStats.Add("HelmFalse[STR]", 200);
            maxItemStats.Add("HelmFalse[VIT]", 200);
            maxItemStats.Add("HelmFalse[AS%]", -1);
            maxItemStats.Add("HelmFalse[CRIT%]", 6);
            maxItemStats.Add("HelmFalse[CRITDMG%]", -1);
            maxItemStats.Add("HelmFalse[MAXDMG]", -1);
            maxItemStats.Add("HelmFalse[MINDMG]", -1);
            maxItemStats.Add("HelmFalse[BLOCK%]", -1);
            maxItemStats.Add("HelmFalse[ARMORBONUS]", 397);
            maxItemStats.Add("HelmFalse[THORNS]", 1454);
            maxItemStats.Add("HelmFalse[RESARCAN]", 60);
            maxItemStats.Add("HelmFalse[RESCOLD]", 60);
            maxItemStats.Add("HelmFalse[RESFIRE]", 60);
            maxItemStats.Add("HelmFalse[RESHOLY]", 60);
            maxItemStats.Add("HelmFalse[RESLIGHTNING]", 60);
            maxItemStats.Add("HelmFalse[RESPHYSICAL]", 60);
            maxItemStats.Add("HelmFalse[RESPOISON]", 60);
            maxItemStats.Add("HelmFalse[ALLRES]", 80);
            maxItemStats.Add("HelmFalse[GLOBEBONUS]", 12794);
            maxItemStats.Add("HelmFalse[LIFE%]", 0.12);
            maxItemStats.Add("HelmFalse[LOH]", -1);
            maxItemStats.Add("HelmFalse[REGEN]", 342);
            maxItemStats.Add("HelmFalse[LS%]", -1);
            maxItemStats.Add("HelmFalse[GF%]", 0.25);
            maxItemStats.Add("HelmFalse[MF%]", 0.2);
            maxItemStats.Add("HelmFalse[MS%]", -1);
            maxItemStats.Add("HelmFalse[PICKRAD]", 7);
            maxItemStats.Add("HelmFalse[SOCKETS]", 1);
            maxItemStats.Add("HelmFalse[MAXFURY]", -1);
            maxItemStats.Add("HelmFalse[HATREDREG]", -1);
            maxItemStats.Add("HelmFalse[MAXDISCIP]", -1);
            maxItemStats.Add("HelmFalse[HEALTHSPIRIT]", -1);
            maxItemStats.Add("HelmFalse[SPIRITREG]", -1);
            maxItemStats.Add("HelmFalse[MANAREG]", -1);
            maxItemStats.Add("HelmFalse[MAXMANA]", -1);
            maxItemStats.Add("HelmFalse[ARCONCRIT]", -1);
            maxItemStats.Add("HelmFalse[MAXARCPOWER]", -1);
            maxItemStats.Add("ChestFalse[DEX]", 200);
            maxItemStats.Add("ChestFalse[INT]", 200);
            maxItemStats.Add("ChestFalse[STR]", 200);
            maxItemStats.Add("ChestFalse[VIT]", 300);
            maxItemStats.Add("ChestFalse[AS%]", -1);
            maxItemStats.Add("ChestFalse[CRIT%]", -1);
            maxItemStats.Add("ChestFalse[CRITDMG%]", -1);
            maxItemStats.Add("ChestFalse[MAXDMG]", -1);
            maxItemStats.Add("ChestFalse[MINDMG]", -1);
            maxItemStats.Add("ChestFalse[BLOCK%]", -1);
            maxItemStats.Add("ChestFalse[ARMORBONUS]", 397);
            maxItemStats.Add("ChestFalse[THORNS]", 2544);
            maxItemStats.Add("ChestFalse[RESARCAN]", 60);
            maxItemStats.Add("ChestFalse[RESCOLD]", 60);
            maxItemStats.Add("ChestFalse[RESFIRE]", 60);
            maxItemStats.Add("ChestFalse[RESHOLY]", 60);
            maxItemStats.Add("ChestFalse[RESLIGHTNING]", 60);
            maxItemStats.Add("ChestFalse[RESPHYSICAL]", 60);
            maxItemStats.Add("ChestFalse[RESPOISON]", 60);
            maxItemStats.Add("ChestFalse[ALLRES]", 80);
            maxItemStats.Add("ChestFalse[GLOBEBONUS]", 12794);
            maxItemStats.Add("ChestFalse[LIFE%]", 0.12);
            maxItemStats.Add("ChestFalse[LOH]", -1);
            maxItemStats.Add("ChestFalse[REGEN]", 599);
            maxItemStats.Add("ChestFalse[LS%]", -1);
            maxItemStats.Add("ChestFalse[GF%]", 0.25);
            maxItemStats.Add("ChestFalse[MF%]", 0.2);
            maxItemStats.Add("ChestFalse[MS%]", -1);
            maxItemStats.Add("ChestFalse[PICKRAD]", 7);
            maxItemStats.Add("ChestFalse[SOCKETS]", 3);
            maxItemStats.Add("ChestFalse[MAXFURY]", -1);
            maxItemStats.Add("ChestFalse[HATREDREG]", -1);
            maxItemStats.Add("ChestFalse[MAXDISCIP]", -1);
            maxItemStats.Add("ChestFalse[HEALTHSPIRIT]", -1);
            maxItemStats.Add("ChestFalse[SPIRITREG]", -1);
            maxItemStats.Add("ChestFalse[MANAREG]", -1);
            maxItemStats.Add("ChestFalse[MAXMANA]", -1);
            maxItemStats.Add("ChestFalse[ARCONCRIT]", -1);
            maxItemStats.Add("ChestFalse[MAXARCPOWER]", -1);
            maxItemStats.Add("CloakFalse[DEX]", 200);
            maxItemStats.Add("CloakFalse[INT]", 200);
            maxItemStats.Add("CloakFalse[STR]", 200);
            maxItemStats.Add("CloakFalse[VIT]", 300);
            maxItemStats.Add("CloakFalse[AS%]", -1);
            maxItemStats.Add("CloakFalse[CRIT%]", -1);
            maxItemStats.Add("CloakFalse[CRITDMG%]", -1);
            maxItemStats.Add("CloakFalse[MAXDMG]", -1);
            maxItemStats.Add("CloakFalse[MINDMG]", -1);
            maxItemStats.Add("CloakFalse[BLOCK%]", -1);
            maxItemStats.Add("CloakFalse[ARMORBONUS]", 397);
            maxItemStats.Add("CloakFalse[THORNS]", 2544);
            maxItemStats.Add("CloakFalse[RESARCAN]", 60);
            maxItemStats.Add("CloakFalse[RESCOLD]", 60);
            maxItemStats.Add("CloakFalse[RESFIRE]", 60);
            maxItemStats.Add("CloakFalse[RESHOLY]", 60);
            maxItemStats.Add("CloakFalse[RESLIGHTNING]", 60);
            maxItemStats.Add("CloakFalse[RESPHYSICAL]", 60);
            maxItemStats.Add("CloakFalse[RESPOISON]", 60);
            maxItemStats.Add("CloakFalse[ALLRES]", 80);
            maxItemStats.Add("CloakFalse[GLOBEBONUS]", 12794);
            maxItemStats.Add("CloakFalse[LIFE%]", 0.12);
            maxItemStats.Add("CloakFalse[LOH]", -1);
            maxItemStats.Add("CloakFalse[REGEN]", 599);
            maxItemStats.Add("CloakFalse[LS%]", -1);
            maxItemStats.Add("CloakFalse[GF%]", 0.25);
            maxItemStats.Add("CloakFalse[MF%]", 0.2);
            maxItemStats.Add("CloakFalse[MS%]", -1);
            maxItemStats.Add("CloakFalse[PICKRAD]", 7);
            maxItemStats.Add("CloakFalse[SOCKETS]", 3);
            maxItemStats.Add("CloakFalse[MAXFURY]", -1);
            maxItemStats.Add("CloakFalse[HATREDREG]", 1.33);
            maxItemStats.Add("CloakFalse[MAXDISCIP]", 10);
            maxItemStats.Add("CloakFalse[HEALTHSPIRIT]", -1);
            maxItemStats.Add("CloakFalse[SPIRITREG]", -1);
            maxItemStats.Add("CloakFalse[MANAREG]", -1);
            maxItemStats.Add("CloakFalse[MAXMANA]", -1);
            maxItemStats.Add("CloakFalse[ARCONCRIT]", -1);
            maxItemStats.Add("CloakFalse[MAXARCPOWER]", -1);
            maxItemStats.Add("BeltFalse[DEX]", 200);
            maxItemStats.Add("BeltFalse[INT]", 200);
            maxItemStats.Add("BeltFalse[STR]", 300);
            maxItemStats.Add("BeltFalse[VIT]", 200);
            maxItemStats.Add("BeltFalse[AS%]", -1);
            maxItemStats.Add("BeltFalse[CRIT%]", -1);
            maxItemStats.Add("BeltFalse[CRITDMG%]", -1);
            maxItemStats.Add("BeltFalse[MAXDMG]", -1);
            maxItemStats.Add("BeltFalse[MINDMG]", -1);
            maxItemStats.Add("BeltFalse[BLOCK%]", -1);
            maxItemStats.Add("BeltFalse[ARMORBONUS]", 265);
            maxItemStats.Add("BeltFalse[THORNS]", 2544);
            maxItemStats.Add("BeltFalse[RESARCAN]", 60);
            maxItemStats.Add("BeltFalse[RESCOLD]", 60);
            maxItemStats.Add("BeltFalse[RESFIRE]", 60);
            maxItemStats.Add("BeltFalse[RESHOLY]", 60);
            maxItemStats.Add("BeltFalse[RESLIGHTNING]", 60);
            maxItemStats.Add("BeltFalse[RESPHYSICAL]", 60);
            maxItemStats.Add("BeltFalse[RESPOISON]", 60);
            maxItemStats.Add("BeltFalse[ALLRES]", 80);
            maxItemStats.Add("BeltFalse[GLOBEBONUS]", 12794);
            maxItemStats.Add("BeltFalse[LIFE%]", 0.12);
            maxItemStats.Add("BeltFalse[LOH]", -1);
            maxItemStats.Add("BeltFalse[REGEN]", 342);
            maxItemStats.Add("BeltFalse[LS%]", -1);
            maxItemStats.Add("BeltFalse[GF%]", 0.25);
            maxItemStats.Add("BeltFalse[MF%]", 0.2);
            maxItemStats.Add("BeltFalse[MS%]", -1);
            maxItemStats.Add("BeltFalse[PICKRAD]", 7);
            maxItemStats.Add("BeltFalse[SOCKETS]", -1);
            maxItemStats.Add("BeltFalse[MAXFURY]", -1);
            maxItemStats.Add("BeltFalse[HATREDREG]", -1);
            maxItemStats.Add("BeltFalse[MAXDISCIP]", -1);
            maxItemStats.Add("BeltFalse[HEALTHSPIRIT]", -1);
            maxItemStats.Add("BeltFalse[SPIRITREG]", -1);
            maxItemStats.Add("BeltFalse[MANAREG]", -1);
            maxItemStats.Add("BeltFalse[MAXMANA]", -1);
            maxItemStats.Add("BeltFalse[ARCONCRIT]", -1);
            maxItemStats.Add("BeltFalse[MAXARCPOWER]", -1);
            maxItemStats.Add("MightyBeltFalse[DEX]", 200);
            maxItemStats.Add("MightyBeltFalse[INT]", 200);
            maxItemStats.Add("MightyBeltFalse[STR]", 300);
            maxItemStats.Add("MightyBeltFalse[VIT]", 200);
            maxItemStats.Add("MightyBeltFalse[AS%]", -1);
            maxItemStats.Add("MightyBeltFalse[CRIT%]", -1);
            maxItemStats.Add("MightyBeltFalse[CRITDMG%]", -1);
            maxItemStats.Add("MightyBeltFalse[MAXDMG]", -1);
            maxItemStats.Add("MightyBeltFalse[MINDMG]", -1);
            maxItemStats.Add("MightyBeltFalse[BLOCK%]", -1);
            maxItemStats.Add("MightyBeltFalse[ARMORBONUS]", 265);
            maxItemStats.Add("MightyBeltFalse[THORNS]", 2544);
            maxItemStats.Add("MightyBeltFalse[RESARCAN]", 60);
            maxItemStats.Add("MightyBeltFalse[RESCOLD]", 60);
            maxItemStats.Add("MightyBeltFalse[RESFIRE]", 60);
            maxItemStats.Add("MightyBeltFalse[RESHOLY]", 60);
            maxItemStats.Add("MightyBeltFalse[RESLIGHTNING]", 60);
            maxItemStats.Add("MightyBeltFalse[RESPHYSICAL]", 60);
            maxItemStats.Add("MightyBeltFalse[RESPOISON]", 60);
            maxItemStats.Add("MightyBeltFalse[ALLRES]", 80);
            maxItemStats.Add("MightyBeltFalse[GLOBEBONUS]", 12794);
            maxItemStats.Add("MightyBeltFalse[LIFE%]", 0.12);
            maxItemStats.Add("MightyBeltFalse[LOH]", -1);
            maxItemStats.Add("MightyBeltFalse[REGEN]", 342);
            maxItemStats.Add("MightyBeltFalse[LS%]", 0.03);
            maxItemStats.Add("MightyBeltFalse[GF%]", 0.25);
            maxItemStats.Add("MightyBeltFalse[MF%]", 0.2);
            maxItemStats.Add("MightyBeltFalse[MS%]", -1);
            maxItemStats.Add("MightyBeltFalse[PICKRAD]", 7);
            maxItemStats.Add("MightyBeltFalse[SOCKETS]", -1);
            maxItemStats.Add("MightyBeltFalse[MAXFURY]", -1);
            maxItemStats.Add("MightyBeltFalse[HATREDREG]", -1);
            maxItemStats.Add("MightyBeltFalse[MAXDISCIP]", -1);
            maxItemStats.Add("MightyBeltFalse[HEALTHSPIRIT]", -1);
            maxItemStats.Add("MightyBeltFalse[SPIRITREG]", -1);
            maxItemStats.Add("MightyBeltFalse[MANAREG]", -1);
            maxItemStats.Add("MightyBeltFalse[MAXMANA]", -1);
            maxItemStats.Add("MightyBeltFalse[ARCONCRIT]", -1);
            maxItemStats.Add("MightyBeltFalse[MAXARCPOWER]", -1);
            maxItemStats.Add("LegsFalse[DEX]", 200);
            maxItemStats.Add("LegsFalse[INT]", 200);
            maxItemStats.Add("LegsFalse[STR]", 200);
            maxItemStats.Add("LegsFalse[VIT]", 300);
            maxItemStats.Add("LegsFalse[AS%]", -1);
            maxItemStats.Add("LegsFalse[CRIT%]", -1);
            maxItemStats.Add("LegsFalse[CRITDMG%]", -1);
            maxItemStats.Add("LegsFalse[MAXDMG]", -1);
            maxItemStats.Add("LegsFalse[MINDMG]", -1);
            maxItemStats.Add("LegsFalse[BLOCK%]", -1);
            maxItemStats.Add("LegsFalse[ARMORBONUS]", 397);
            maxItemStats.Add("LegsFalse[THORNS]", 1454);
            maxItemStats.Add("LegsFalse[RESARCAN]", 60);
            maxItemStats.Add("LegsFalse[RESCOLD]", 60);
            maxItemStats.Add("LegsFalse[RESFIRE]", 60);
            maxItemStats.Add("LegsFalse[RESHOLY]", 60);
            maxItemStats.Add("LegsFalse[RESLIGHTNING]", 60);
            maxItemStats.Add("LegsFalse[RESPHYSICAL]", 60);
            maxItemStats.Add("LegsFalse[RESPOISON]", 60);
            maxItemStats.Add("LegsFalse[ALLRES]", 80);
            maxItemStats.Add("LegsFalse[GLOBEBONUS]", 12794);
            maxItemStats.Add("LegsFalse[LIFE%]", -1);
            maxItemStats.Add("LegsFalse[LOH]", -1);
            maxItemStats.Add("LegsFalse[REGEN]", 342);
            maxItemStats.Add("LegsFalse[LS%]", -1);
            maxItemStats.Add("LegsFalse[GF%]", 0.25);
            maxItemStats.Add("LegsFalse[MF%]", 0.2);
            maxItemStats.Add("LegsFalse[MS%]", -1);
            maxItemStats.Add("LegsFalse[PICKRAD]", 7);
            maxItemStats.Add("LegsFalse[SOCKETS]", 2);
            maxItemStats.Add("LegsFalse[MAXFURY]", -1);
            maxItemStats.Add("LegsFalse[HATREDREG]", -1);
            maxItemStats.Add("LegsFalse[MAXDISCIP]", -1);
            maxItemStats.Add("LegsFalse[HEALTHSPIRIT]", -1);
            maxItemStats.Add("LegsFalse[SPIRITREG]", -1);
            maxItemStats.Add("LegsFalse[MANAREG]", -1);
            maxItemStats.Add("LegsFalse[MAXMANA]", -1);
            maxItemStats.Add("LegsFalse[ARCONCRIT]", -1);
            maxItemStats.Add("LegsFalse[MAXARCPOWER]", -1);
            maxItemStats.Add("BootsFalse[DEX]", 300);
            maxItemStats.Add("BootsFalse[INT]", 200);
            maxItemStats.Add("BootsFalse[STR]", 200);
            maxItemStats.Add("BootsFalse[VIT]", 200);
            maxItemStats.Add("BootsFalse[AS%]", -1);
            maxItemStats.Add("BootsFalse[CRIT%]", -1);
            maxItemStats.Add("BootsFalse[CRITDMG%]", -1);
            maxItemStats.Add("BootsFalse[MAXDMG]", -1);
            maxItemStats.Add("BootsFalse[MINDMG]", -1);
            maxItemStats.Add("BootsFalse[BLOCK%]", -1);
            maxItemStats.Add("BootsFalse[ARMORBONUS]", 265);
            maxItemStats.Add("BootsFalse[THORNS]", 1454);
            maxItemStats.Add("BootsFalse[RESARCAN]", 60);
            maxItemStats.Add("BootsFalse[RESCOLD]", 60);
            maxItemStats.Add("BootsFalse[RESFIRE]", 60);
            maxItemStats.Add("BootsFalse[RESHOLY]", 60);
            maxItemStats.Add("BootsFalse[RESLIGHTNING]", 60);
            maxItemStats.Add("BootsFalse[RESPHYSICAL]", 60);
            maxItemStats.Add("BootsFalse[RESPOISON]", 60);
            maxItemStats.Add("BootsFalse[ALLRES]", 80);
            maxItemStats.Add("BootsFalse[GLOBEBONUS]", 12794);
            maxItemStats.Add("BootsFalse[LIFE%]", -1);
            maxItemStats.Add("BootsFalse[LOH]", -1);
            maxItemStats.Add("BootsFalse[REGEN]", 342);
            maxItemStats.Add("BootsFalse[LS%]", -1);
            maxItemStats.Add("BootsFalse[GF%]", 0.25);
            maxItemStats.Add("BootsFalse[MF%]", 0.2);
            maxItemStats.Add("BootsFalse[MS%]", 0.12);
            maxItemStats.Add("BootsFalse[PICKRAD]", 7);
            maxItemStats.Add("BootsFalse[SOCKETS]", -1);
            maxItemStats.Add("BootsFalse[MAXFURY]", -1);
            maxItemStats.Add("BootsFalse[HATREDREG]", -1);
            maxItemStats.Add("BootsFalse[MAXDISCIP]", -1);
            maxItemStats.Add("BootsFalse[HEALTHSPIRIT]", -1);
            maxItemStats.Add("BootsFalse[SPIRITREG]", -1);
            maxItemStats.Add("BootsFalse[MANAREG]", -1);
            maxItemStats.Add("BootsFalse[MAXMANA]", -1);
            maxItemStats.Add("BootsFalse[ARCONCRIT]", -1);
            maxItemStats.Add("BootsFalse[MAXARCPOWER]", -1);
            maxItemStats.Add("BracerFalse[DEX]", 200);
            maxItemStats.Add("BracerFalse[INT]", 200);
            maxItemStats.Add("BracerFalse[STR]", 200);
            maxItemStats.Add("BracerFalse[VIT]", 200);
            maxItemStats.Add("BracerFalse[AS%]", -1);
            maxItemStats.Add("BracerFalse[CRIT%]", 6);
            maxItemStats.Add("BracerFalse[CRITDMG%]", -1);
            maxItemStats.Add("BracerFalse[MAXDMG]", -1);
            maxItemStats.Add("BracerFalse[MINDMG]", -1);
            maxItemStats.Add("BracerFalse[BLOCK%]", -1);
            maxItemStats.Add("BracerFalse[ARMORBONUS]", 265);
            maxItemStats.Add("BracerFalse[THORNS]", 1454);
            maxItemStats.Add("BracerFalse[RESARCAN]", 60);
            maxItemStats.Add("BracerFalse[RESCOLD]", 60);
            maxItemStats.Add("BracerFalse[RESFIRE]", 60);
            maxItemStats.Add("BracerFalse[RESHOLY]", 60);
            maxItemStats.Add("BracerFalse[RESLIGHTNING]", 60);
            maxItemStats.Add("BracerFalse[RESPHYSICAL]", 60);
            maxItemStats.Add("BracerFalse[RESPOISON]", 60);
            maxItemStats.Add("BracerFalse[ALLRES]", 80);
            maxItemStats.Add("BracerFalse[GLOBEBONUS]", 12794);
            maxItemStats.Add("BracerFalse[LIFE%]", -1);
            maxItemStats.Add("BracerFalse[LOH]", -1);
            maxItemStats.Add("BracerFalse[REGEN]", 342);
            maxItemStats.Add("BracerFalse[LS%]", -1);
            maxItemStats.Add("BracerFalse[GF%]", 0.25);
            maxItemStats.Add("BracerFalse[MF%]", 0.2);
            maxItemStats.Add("BracerFalse[MS%]", -1);
            maxItemStats.Add("BracerFalse[PICKRAD]", 7);
            maxItemStats.Add("BracerFalse[SOCKETS]", -1);
            maxItemStats.Add("BracerFalse[MAXFURY]", -1);
            maxItemStats.Add("BracerFalse[HATREDREG]", -1);
            maxItemStats.Add("BracerFalse[MAXDISCIP]", -1);
            maxItemStats.Add("BracerFalse[HEALTHSPIRIT]", -1);
            maxItemStats.Add("BracerFalse[SPIRITREG]", -1);
            maxItemStats.Add("BracerFalse[MANAREG]", -1);
            maxItemStats.Add("BracerFalse[MAXMANA]", -1);
            maxItemStats.Add("BracerFalse[ARCONCRIT]", -1);
            maxItemStats.Add("BracerFalse[MAXARCPOWER]", -1);
            maxItemStats.Add("GlovesFalse[DEX]", 300);
            maxItemStats.Add("GlovesFalse[INT]", 300);
            maxItemStats.Add("GlovesFalse[STR]", 200);
            maxItemStats.Add("GlovesFalse[VIT]", 200);
            maxItemStats.Add("GlovesFalse[AS%]", 9);
            maxItemStats.Add("GlovesFalse[CRIT%]", 10);
            maxItemStats.Add("GlovesFalse[CRITDMG%]", 50);
            maxItemStats.Add("GlovesFalse[MAXDMG]", -1);
            maxItemStats.Add("GlovesFalse[MINDMG]", -1);
            maxItemStats.Add("GlovesFalse[BLOCK%]", -1);
            maxItemStats.Add("GlovesFalse[ARMORBONUS]", 265);
            maxItemStats.Add("GlovesFalse[THORNS]", 1454);
            maxItemStats.Add("GlovesFalse[RESARCAN]", 60);
            maxItemStats.Add("GlovesFalse[RESCOLD]", 60);
            maxItemStats.Add("GlovesFalse[RESFIRE]", 60);
            maxItemStats.Add("GlovesFalse[RESHOLY]", 60);
            maxItemStats.Add("GlovesFalse[RESLIGHTNING]", 60);
            maxItemStats.Add("GlovesFalse[RESPHYSICAL]", 60);
            maxItemStats.Add("GlovesFalse[RESPOISON]", 60);
            maxItemStats.Add("GlovesFalse[ALLRES]", 80);
            maxItemStats.Add("GlovesFalse[GLOBEBONUS]", 12794);
            maxItemStats.Add("GlovesFalse[LIFE%]", -1);
            maxItemStats.Add("GlovesFalse[LOH]", -1);
            maxItemStats.Add("GlovesFalse[REGEN]", 342);
            maxItemStats.Add("GlovesFalse[LS%]", -1);
            maxItemStats.Add("GlovesFalse[GF%]", 0.25);
            maxItemStats.Add("GlovesFalse[MF%]", 0.2);
            maxItemStats.Add("GlovesFalse[MS%]", -1);
            maxItemStats.Add("GlovesFalse[PICKRAD]", 7);
            maxItemStats.Add("GlovesFalse[SOCKETS]", -1);
            maxItemStats.Add("GlovesFalse[MAXFURY]", -1);
            maxItemStats.Add("GlovesFalse[HATREDREG]", -1);
            maxItemStats.Add("GlovesFalse[MAXDISCIP]", -1);
            maxItemStats.Add("GlovesFalse[HEALTHSPIRIT]", -1);
            maxItemStats.Add("GlovesFalse[SPIRITREG]", -1);
            maxItemStats.Add("GlovesFalse[MANAREG]", -1);
            maxItemStats.Add("GlovesFalse[MAXMANA]", -1);
            maxItemStats.Add("GlovesFalse[ARCONCRIT]", -1);
            maxItemStats.Add("GlovesFalse[MAXARCPOWER]", -1);
            maxItemStats.Add("ShoulderFalse[DEX]", 200);
            maxItemStats.Add("ShoulderFalse[INT]", 200);
            maxItemStats.Add("ShoulderFalse[STR]", 300);
            maxItemStats.Add("ShoulderFalse[VIT]", 200);
            maxItemStats.Add("ShoulderFalse[AS%]", -1);
            maxItemStats.Add("ShoulderFalse[CRIT%]", -1);
            maxItemStats.Add("ShoulderFalse[CRITDMG%]", -1);
            maxItemStats.Add("ShoulderFalse[MAXDMG]", -1);
            maxItemStats.Add("ShoulderFalse[MINDMG]", -1);
            maxItemStats.Add("ShoulderFalse[BLOCK%]", -1);
            maxItemStats.Add("ShoulderFalse[ARMORBONUS]", 265);
            maxItemStats.Add("ShoulderFalse[THORNS]", 2544);
            maxItemStats.Add("ShoulderFalse[RESARCAN]", 60);
            maxItemStats.Add("ShoulderFalse[RESCOLD]", 60);
            maxItemStats.Add("ShoulderFalse[RESFIRE]", 60);
            maxItemStats.Add("ShoulderFalse[RESHOLY]", 60);
            maxItemStats.Add("ShoulderFalse[RESLIGHTNING]", 60);
            maxItemStats.Add("ShoulderFalse[RESPHYSICAL]", 60);
            maxItemStats.Add("ShoulderFalse[RESPOISON]", 60);
            maxItemStats.Add("ShoulderFalse[ALLRES]", 80);
            maxItemStats.Add("ShoulderFalse[GLOBEBONUS]", 12794);
            maxItemStats.Add("ShoulderFalse[LIFE%]", 0.12);
            maxItemStats.Add("ShoulderFalse[LOH]", -1);
            maxItemStats.Add("ShoulderFalse[REGEN]", 342);
            maxItemStats.Add("ShoulderFalse[LS%]", -1);
            maxItemStats.Add("ShoulderFalse[GF%]", 0.25);
            maxItemStats.Add("ShoulderFalse[MF%]", 0.2);
            maxItemStats.Add("ShoulderFalse[MS%]", -1);
            maxItemStats.Add("ShoulderFalse[PICKRAD]", 7);
            maxItemStats.Add("ShoulderFalse[SOCKETS]", -1);
            maxItemStats.Add("ShoulderFalse[MAXFURY]", -1);
            maxItemStats.Add("ShoulderFalse[HATREDREG]", -1);
            maxItemStats.Add("ShoulderFalse[MAXDISCIP]", -1);
            maxItemStats.Add("ShoulderFalse[HEALTHSPIRIT]", -1);
            maxItemStats.Add("ShoulderFalse[SPIRITREG]", -1);
            maxItemStats.Add("ShoulderFalse[MANAREG]", -1);
            maxItemStats.Add("ShoulderFalse[MAXMANA]", -1);
            maxItemStats.Add("ShoulderFalse[ARCONCRIT]", -1);
            maxItemStats.Add("ShoulderFalse[MAXARCPOWER]", -1);
            maxItemStats.Add("AmuletFalse[DEX]", 350);
            maxItemStats.Add("AmuletFalse[INT]", 350);
            maxItemStats.Add("AmuletFalse[STR]", 350);
            maxItemStats.Add("AmuletFalse[VIT]", 350);
            maxItemStats.Add("AmuletFalse[AS%]", 9);
            maxItemStats.Add("AmuletFalse[CRIT%]", 10);
            maxItemStats.Add("AmuletFalse[CRITDMG%]", 100);
            maxItemStats.Add("AmuletFalse[MAXDMG]", 104);
            maxItemStats.Add("AmuletFalse[MINDMG]", 36);
            maxItemStats.Add("AmuletFalse[BLOCK%]", -1);
            maxItemStats.Add("AmuletFalse[ARMORBONUS]", 397);
            maxItemStats.Add("AmuletFalse[THORNS]", 2544);
            maxItemStats.Add("AmuletFalse[RESARCAN]", 60);
            maxItemStats.Add("AmuletFalse[RESCOLD]", 60);
            maxItemStats.Add("AmuletFalse[RESFIRE]", 60);
            maxItemStats.Add("AmuletFalse[RESHOLY]", 60);
            maxItemStats.Add("AmuletFalse[RESLIGHTNING]", 60);
            maxItemStats.Add("AmuletFalse[RESPHYSICAL]", 60);
            maxItemStats.Add("AmuletFalse[RESPOISON]", 60);
            maxItemStats.Add("AmuletFalse[ALLRES]", 80);
            maxItemStats.Add("AmuletFalse[GLOBEBONUS]", 12794);
            maxItemStats.Add("AmuletFalse[LIFE%]", 0.16);
            maxItemStats.Add("AmuletFalse[LOH]", 959);
            maxItemStats.Add("AmuletFalse[REGEN]", 599);
            maxItemStats.Add("AmuletFalse[LS%]", -1);
            maxItemStats.Add("AmuletFalse[GF%]", 0.5);
            maxItemStats.Add("AmuletFalse[MF%]", 0.45);
            maxItemStats.Add("AmuletFalse[MS%]", -1);
            maxItemStats.Add("AmuletFalse[PICKRAD]", -1);
            maxItemStats.Add("AmuletFalse[SOCKETS]", 1);
            maxItemStats.Add("AmuletFalse[MAXFURY]", -1);
            maxItemStats.Add("AmuletFalse[HATREDREG]", -1);
            maxItemStats.Add("AmuletFalse[MAXDISCIP]", -1);
            maxItemStats.Add("AmuletFalse[HEALTHSPIRIT]", -1);
            maxItemStats.Add("AmuletFalse[SPIRITREG]", -1);
            maxItemStats.Add("AmuletFalse[MANAREG]", -1);
            maxItemStats.Add("AmuletFalse[MAXMANA]", -1);
            maxItemStats.Add("AmuletFalse[ARCONCRIT]", -1);
            maxItemStats.Add("AmuletFalse[MAXARCPOWER]", -1);
            maxItemStats.Add("RingFalse[DEX]", 200);
            maxItemStats.Add("RingFalse[INT]", 200);
            maxItemStats.Add("RingFalse[STR]", 200);
            maxItemStats.Add("RingFalse[VIT]", 200);
            maxItemStats.Add("RingFalse[AS%]", 9);
            maxItemStats.Add("RingFalse[CRIT%]", 6);
            maxItemStats.Add("RingFalse[CRITDMG%]", 50);
            maxItemStats.Add("RingFalse[MAXDMG]", 104);
            maxItemStats.Add("RingFalse[MINDMG]", 36);
            maxItemStats.Add("RingFalse[BLOCK%]", -1);
            maxItemStats.Add("RingFalse[ARMORBONUS]", 265);
            maxItemStats.Add("RingFalse[THORNS]", 1454);
            maxItemStats.Add("RingFalse[RESARCAN]", 60);
            maxItemStats.Add("RingFalse[RESCOLD]", 60);
            maxItemStats.Add("RingFalse[RESFIRE]", 60);
            maxItemStats.Add("RingFalse[RESHOLY]", 60);
            maxItemStats.Add("RingFalse[RESLIGHTNING]", 60);
            maxItemStats.Add("RingFalse[RESPHYSICAL]", 60);
            maxItemStats.Add("RingFalse[RESPOISON]", 60);
            maxItemStats.Add("RingFalse[ALLRES]", 80);
            maxItemStats.Add("RingFalse[GLOBEBONUS]", 12794);
            maxItemStats.Add("RingFalse[LIFE%]", 0.12);
            maxItemStats.Add("RingFalse[LOH]", 479);
            maxItemStats.Add("RingFalse[REGEN]", 342);
            maxItemStats.Add("RingFalse[LS%]", -1);
            maxItemStats.Add("RingFalse[GF%]", 0.25);
            maxItemStats.Add("RingFalse[MF%]", 0.2);
            maxItemStats.Add("RingFalse[MS%]", -1);
            maxItemStats.Add("RingFalse[PICKRAD]", -1);
            maxItemStats.Add("RingFalse[SOCKETS]", 1);
            maxItemStats.Add("RingFalse[MAXFURY]", -1);
            maxItemStats.Add("RingFalse[HATREDREG]", -1);
            maxItemStats.Add("RingFalse[MAXDISCIP]", -1);
            maxItemStats.Add("RingFalse[HEALTHSPIRIT]", -1);
            maxItemStats.Add("RingFalse[SPIRITREG]", -1);
            maxItemStats.Add("RingFalse[MANAREG]", -1);
            maxItemStats.Add("RingFalse[MAXMANA]", -1);
            maxItemStats.Add("RingFalse[ARCONCRIT]", -1);
            maxItemStats.Add("RingFalse[MAXARCPOWER]", -1);
            maxItemStats.Add("ShieldFalse[DEX]", 350);
            maxItemStats.Add("ShieldFalse[INT]", 350);
            maxItemStats.Add("ShieldFalse[STR]", 350);
            maxItemStats.Add("ShieldFalse[VIT]", 350);
            maxItemStats.Add("ShieldFalse[AS%]", -1);
            maxItemStats.Add("ShieldFalse[CRIT%]", 10);
            maxItemStats.Add("ShieldFalse[CRITDMG%]", -1);
            maxItemStats.Add("ShieldFalse[MAXDMG]", -1);
            maxItemStats.Add("ShieldFalse[MINDMG]", -1);
            maxItemStats.Add("ShieldFalse[BLOCK%]", 0.09);
            maxItemStats.Add("ShieldFalse[ARMORBONUS]", 397);
            maxItemStats.Add("ShieldFalse[THORNS]", 2544);
            maxItemStats.Add("ShieldFalse[RESARCAN]", 60);
            maxItemStats.Add("ShieldFalse[RESCOLD]", 60);
            maxItemStats.Add("ShieldFalse[RESFIRE]", 60);
            maxItemStats.Add("ShieldFalse[RESHOLY]", 60);
            maxItemStats.Add("ShieldFalse[RESLIGHTNING]", 60);
            maxItemStats.Add("ShieldFalse[RESPHYSICAL]", 60);
            maxItemStats.Add("ShieldFalse[RESPOISON]", 60);
            maxItemStats.Add("ShieldFalse[ALLRES]", 80);
            maxItemStats.Add("ShieldFalse[GLOBEBONUS]", 12794);
            maxItemStats.Add("ShieldFalse[LIFE%]", 0.16);
            maxItemStats.Add("ShieldFalse[LOH]", -1);
            maxItemStats.Add("ShieldFalse[REGEN]", 342);
            maxItemStats.Add("ShieldFalse[LS%]", -1);
            maxItemStats.Add("ShieldFalse[GF%]", 0.25);
            maxItemStats.Add("ShieldFalse[MF%]", 0.2);
            maxItemStats.Add("ShieldFalse[MS%]", -1);
            maxItemStats.Add("ShieldFalse[PICKRAD]", -1);
            maxItemStats.Add("ShieldFalse[SOCKETS]", 1);
            maxItemStats.Add("ShieldFalse[MAXFURY]", -1);
            maxItemStats.Add("ShieldFalse[HATREDREG]", -1);
            maxItemStats.Add("ShieldFalse[MAXDISCIP]", -1);
            maxItemStats.Add("ShieldFalse[HEALTHSPIRIT]", -1);
            maxItemStats.Add("ShieldFalse[SPIRITREG]", -1);
            maxItemStats.Add("ShieldFalse[MANAREG]", -1);
            maxItemStats.Add("ShieldFalse[MAXMANA]", -1);
            maxItemStats.Add("ShieldFalse[ARCONCRIT]", -1);
            maxItemStats.Add("ShieldFalse[MAXARCPOWER]", -1);
            maxItemStats.Add("QuiverFalse[DEX]", 350);
            maxItemStats.Add("QuiverFalse[INT]", 350);
            maxItemStats.Add("QuiverFalse[STR]", 350);
            maxItemStats.Add("QuiverFalse[VIT]", 350);
            maxItemStats.Add("QuiverFalse[AS%]", 15);
            maxItemStats.Add("QuiverFalse[CRIT%]", 10);
            maxItemStats.Add("QuiverFalse[CRITDMG%]", -1);
            maxItemStats.Add("QuiverFalse[MAXDMG]", -1);
            maxItemStats.Add("QuiverFalse[MINDMG]", -1);
            maxItemStats.Add("QuiverFalse[BLOCK%]", -1);
            maxItemStats.Add("QuiverFalse[ARMORBONUS]", -1);
            maxItemStats.Add("QuiverFalse[THORNS]", 1454);
            maxItemStats.Add("QuiverFalse[RESARCAN]", -1);
            maxItemStats.Add("QuiverFalse[RESCOLD]", -1);
            maxItemStats.Add("QuiverFalse[RESFIRE]", -1);
            maxItemStats.Add("QuiverFalse[RESHOLY]", -1);
            maxItemStats.Add("QuiverFalse[RESLIGHTNING]", -1);
            maxItemStats.Add("QuiverFalse[RESPHYSICAL]", -1);
            maxItemStats.Add("QuiverFalse[RESPOISON]", -1);
            maxItemStats.Add("QuiverFalse[ALLRES]", -1);
            maxItemStats.Add("QuiverFalse[GLOBEBONUS]", 12794);
            maxItemStats.Add("QuiverFalse[LIFE%]", 0.12);
            maxItemStats.Add("QuiverFalse[LOH]", -1);
            maxItemStats.Add("QuiverFalse[REGEN]", 342);
            maxItemStats.Add("QuiverFalse[LS%]", -1);
            maxItemStats.Add("QuiverFalse[GF%]", 0.25);
            maxItemStats.Add("QuiverFalse[MF%]", 0.2);
            maxItemStats.Add("QuiverFalse[MS%]", -1);
            maxItemStats.Add("QuiverFalse[PICKRAD]", -1);
            maxItemStats.Add("QuiverFalse[SOCKETS]", 1);
            maxItemStats.Add("QuiverFalse[MAXFURY]", -1);
            maxItemStats.Add("QuiverFalse[HATREDREG]", 1.33);
            maxItemStats.Add("QuiverFalse[MAXDISCIP]", 10);
            maxItemStats.Add("QuiverFalse[HEALTHSPIRIT]", -1);
            maxItemStats.Add("QuiverFalse[SPIRITREG]", -1);
            maxItemStats.Add("QuiverFalse[MANAREG]", -1);
            maxItemStats.Add("QuiverFalse[MAXMANA]", -1);
            maxItemStats.Add("QuiverFalse[ARCONCRIT]", -1);
            maxItemStats.Add("QuiverFalse[MAXARCPOWER]", -1);
            maxItemStats.Add("MojoFalse[DEX]", 350);
            maxItemStats.Add("MojoFalse[INT]", 350);
            maxItemStats.Add("MojoFalse[STR]", 350);
            maxItemStats.Add("MojoFalse[VIT]", 350);
            maxItemStats.Add("MojoFalse[AS%]", -1);
            maxItemStats.Add("MojoFalse[CRIT%]", 10);
            maxItemStats.Add("MojoFalse[CRITDMG%]", -1);
            maxItemStats.Add("MojoFalse[MAXDMG]", -1);
            maxItemStats.Add("MojoFalse[MINDMG]", -1);
            maxItemStats.Add("MojoFalse[BLOCK%]", -1);
            maxItemStats.Add("MojoFalse[ARMORBONUS]", -1);
            maxItemStats.Add("MojoFalse[THORNS]", 1454);
            maxItemStats.Add("MojoFalse[RESARCAN]", -1);
            maxItemStats.Add("MojoFalse[RESCOLD]", -1);
            maxItemStats.Add("MojoFalse[RESFIRE]", -1);
            maxItemStats.Add("MojoFalse[RESHOLY]", -1);
            maxItemStats.Add("MojoFalse[RESLIGHTNING]", -1);
            maxItemStats.Add("MojoFalse[RESPHYSICAL]", -1);
            maxItemStats.Add("MojoFalse[RESPOISON]", -1);
            maxItemStats.Add("MojoFalse[ALLRES]", -1);
            maxItemStats.Add("MojoFalse[GLOBEBONUS]", 12794);
            maxItemStats.Add("MojoFalse[LIFE%]", 0.12);
            maxItemStats.Add("MojoFalse[LOH]", -1);
            maxItemStats.Add("MojoFalse[REGEN]", 342);
            maxItemStats.Add("MojoFalse[LS%]", -1);
            maxItemStats.Add("MojoFalse[GF%]", 0.25);
            maxItemStats.Add("MojoFalse[MF%]", 0.2);
            maxItemStats.Add("MojoFalse[MS%]", -1);
            maxItemStats.Add("MojoFalse[PICKRAD]", -1);
            maxItemStats.Add("MojoFalse[SOCKETS]", 1);
            maxItemStats.Add("MojoFalse[MAXFURY]", -1);
            maxItemStats.Add("MojoFalse[HATREDREG]", -1);
            maxItemStats.Add("MojoFalse[MAXDISCIP]", -1);
            maxItemStats.Add("MojoFalse[HEALTHSPIRIT]", -1);
            maxItemStats.Add("MojoFalse[SPIRITREG]", -1);
            maxItemStats.Add("MojoFalse[MANAREG]", 14);
            maxItemStats.Add("MojoFalse[MAXMANA]", 150);
            maxItemStats.Add("MojoFalse[ARCONCRIT]", -1);
            maxItemStats.Add("MojoFalse[MAXARCPOWER]", -1);
            maxItemStats.Add("SourceFalse[DEX]", 350);
            maxItemStats.Add("SourceFalse[INT]", 350);
            maxItemStats.Add("SourceFalse[STR]", 350);
            maxItemStats.Add("SourceFalse[VIT]", 350);
            maxItemStats.Add("SourceFalse[AS%]", -1);
            maxItemStats.Add("SourceFalse[CRIT%]", 10);
            maxItemStats.Add("SourceFalse[CRITDMG%]", -1);
            maxItemStats.Add("SourceFalse[MAXDMG]", -1);
            maxItemStats.Add("SourceFalse[MINDMG]", -1);
            maxItemStats.Add("SourceFalse[BLOCK%]", -1);
            maxItemStats.Add("SourceFalse[ARMORBONUS]", -1);
            maxItemStats.Add("SourceFalse[THORNS]", 1454);
            maxItemStats.Add("SourceFalse[RESARCAN]", -1);
            maxItemStats.Add("SourceFalse[RESCOLD]", -1);
            maxItemStats.Add("SourceFalse[RESFIRE]", -1);
            maxItemStats.Add("SourceFalse[RESHOLY]", -1);
            maxItemStats.Add("SourceFalse[RESLIGHTNING]", -1);
            maxItemStats.Add("SourceFalse[RESPHYSICAL]", -1);
            maxItemStats.Add("SourceFalse[RESPOISON]", -1);
            maxItemStats.Add("SourceFalse[ALLRES]", -1);
            maxItemStats.Add("SourceFalse[GLOBEBONUS]", 12794);
            maxItemStats.Add("SourceFalse[LIFE%]", 0.12);
            maxItemStats.Add("SourceFalse[LOH]", -1);
            maxItemStats.Add("SourceFalse[REGEN]", 342);
            maxItemStats.Add("SourceFalse[LS%]", -1);
            maxItemStats.Add("SourceFalse[GF%]", 0.25);
            maxItemStats.Add("SourceFalse[MF%]", 0.2);
            maxItemStats.Add("SourceFalse[MS%]", -1);
            maxItemStats.Add("SourceFalse[PICKRAD]", -1);
            maxItemStats.Add("SourceFalse[SOCKETS]", 1);
            maxItemStats.Add("SourceFalse[MAXFURY]", -1);
            maxItemStats.Add("SourceFalse[HATREDREG]", -1);
            maxItemStats.Add("SourceFalse[MAXDISCIP]", -1);
            maxItemStats.Add("SourceFalse[HEALTHSPIRIT]", -1);
            maxItemStats.Add("SourceFalse[SPIRITREG]", -1);
            maxItemStats.Add("SourceFalse[MANAREG]", -1);
            maxItemStats.Add("SourceFalse[MAXMANA]", -1);
            maxItemStats.Add("SourceFalse[ARCONCRIT]", 10);
            maxItemStats.Add("SourceFalse[MAXARCPOWER]", 15);

            foreach (ItemType weapon in oneHandWeapons)
            {
                maxItemStats.Add(weapon.ToString() + "False[DEX]", 350);
                maxItemStats.Add(weapon.ToString() + "False[INT]", 350);
                maxItemStats.Add(weapon.ToString() + "False[STR]", 350);
                maxItemStats.Add(weapon.ToString() + "False[VIT]", 350);
                maxItemStats.Add(weapon.ToString() + "False[AS%]", 11);
                maxItemStats.Add(weapon.ToString() + "False[CRIT%]", -1);
                maxItemStats.Add(weapon.ToString() + "False[CRITDMG%]", 100);
                maxItemStats.Add(weapon.ToString() + "False[MAXDMG]", 411);
                maxItemStats.Add(weapon.ToString() + "False[MINDMG]", 316);
                maxItemStats.Add(weapon.ToString() + "False[BLOCK%]", -1);
                maxItemStats.Add(weapon.ToString() + "False[ARMORBONUS]", -1);
                maxItemStats.Add(weapon.ToString() + "False[THORNS]", -1);
                maxItemStats.Add(weapon.ToString() + "False[RESARCAN]", -1);
                maxItemStats.Add(weapon.ToString() + "False[RESCOLD]", -1);
                maxItemStats.Add(weapon.ToString() + "False[RESFIRE]", -1);
                maxItemStats.Add(weapon.ToString() + "False[RESHOLY]", -1);
                maxItemStats.Add(weapon.ToString() + "False[RESLIGHTNING]", -1);
                maxItemStats.Add(weapon.ToString() + "False[RESPHYSICAL]", -1);
                maxItemStats.Add(weapon.ToString() + "False[RESPOISON]", -1);
                maxItemStats.Add(weapon.ToString() + "False[ALLRES]", -1);
                maxItemStats.Add(weapon.ToString() + "False[GLOBEBONUS]", -1);
                maxItemStats.Add(weapon.ToString() + "False[LIFE%]", -1);
                maxItemStats.Add(weapon.ToString() + "False[LOH]", 959);
                maxItemStats.Add(weapon.ToString() + "False[REGEN]", -1);
                maxItemStats.Add(weapon.ToString() + "False[LS%]", 0.03);
                maxItemStats.Add(weapon.ToString() + "False[GF%]", -1);
                maxItemStats.Add(weapon.ToString() + "False[MF%]", -1);
                maxItemStats.Add(weapon.ToString() + "False[MS%]", -1);
                maxItemStats.Add(weapon.ToString() + "False[PICKRAD]", -1);
                maxItemStats.Add(weapon.ToString() + "False[SOCKETS]", 1);
                maxItemStats.Add(weapon.ToString() + "False[MAXFURY]", -1);
                maxItemStats.Add(weapon.ToString() + "False[HATREDREG]", 1.33);
                maxItemStats.Add(weapon.ToString() + "False[MAXDISCIP]", 10);
                maxItemStats.Add(weapon.ToString() + "False[HEALTHSPIRIT]", 64);
                maxItemStats.Add(weapon.ToString() + "False[SPIRITREG]", 2.5);
                maxItemStats.Add(weapon.ToString() + "False[MANAREG]", 14);
                maxItemStats.Add(weapon.ToString() + "False[MAXMANA]", 150);
                maxItemStats.Add(weapon.ToString() + "False[ARCONCRIT]", 10);
                maxItemStats.Add(weapon.ToString() + "False[MAXARCPOWER]", 15);
            }

            foreach (ItemType weapon in twoHandMeleeWeapons)
            {
                maxItemStats.Add(weapon.ToString() + "True[DEX]", 595);
                maxItemStats.Add(weapon.ToString() + "True[INT]", 595);
                maxItemStats.Add(weapon.ToString() + "True[STR]", 595);
                maxItemStats.Add(weapon.ToString() + "True[VIT]", 595);
                maxItemStats.Add(weapon.ToString() + "True[AS%]", 11);
                maxItemStats.Add(weapon.ToString() + "True[CRIT%]", -1);
                maxItemStats.Add(weapon.ToString() + "True[CRITDMG%]", 200);
                maxItemStats.Add(weapon.ToString() + "True[MAXDMG]", 411);
                maxItemStats.Add(weapon.ToString() + "True[MINDMG]", 316);
                maxItemStats.Add(weapon.ToString() + "True[BLOCK%]", -1);
                maxItemStats.Add(weapon.ToString() + "True[ARMORBONUS]", -1);
                maxItemStats.Add(weapon.ToString() + "True[THORNS]", -1);
                maxItemStats.Add(weapon.ToString() + "True[RESARCAN]", -1);
                maxItemStats.Add(weapon.ToString() + "True[RESCOLD]", -1);
                maxItemStats.Add(weapon.ToString() + "True[RESFIRE]", -1);
                maxItemStats.Add(weapon.ToString() + "True[RESHOLY]", -1);
                maxItemStats.Add(weapon.ToString() + "True[RESLIGHTNING]", -1);
                maxItemStats.Add(weapon.ToString() + "True[RESPHYSICAL]", -1);
                maxItemStats.Add(weapon.ToString() + "True[RESPOISON]", -1);
                maxItemStats.Add(weapon.ToString() + "True[ALLRES]", -1);
                maxItemStats.Add(weapon.ToString() + "True[GLOBEBONUS]", -1);
                maxItemStats.Add(weapon.ToString() + "True[LIFE%]", -1);
                maxItemStats.Add(weapon.ToString() + "True[LOH]", 1918);
                maxItemStats.Add(weapon.ToString() + "True[REGEN]", -1);
                maxItemStats.Add(weapon.ToString() + "True[LS%]", 0.06);
                maxItemStats.Add(weapon.ToString() + "True[GF%]", -1);
                maxItemStats.Add(weapon.ToString() + "True[MF%]", -1);
                maxItemStats.Add(weapon.ToString() + "True[MS%]", -1);
                maxItemStats.Add(weapon.ToString() + "True[PICKRAD]", -1);
                maxItemStats.Add(weapon.ToString() + "True[SOCKETS]", 1);
                maxItemStats.Add(weapon.ToString() + "True[MAXFURY]", -1);
                maxItemStats.Add(weapon.ToString() + "True[HATREDREG]", -1);
                maxItemStats.Add(weapon.ToString() + "True[MAXDISCIP]", -1);
                maxItemStats.Add(weapon.ToString() + "True[HEALTHSPIRIT]", 64);
                maxItemStats.Add(weapon.ToString() + "True[SPIRITREG]", 2.5);
                maxItemStats.Add(weapon.ToString() + "True[MANAREG]", -1);
                maxItemStats.Add(weapon.ToString() + "True[MAXMANA]", -1);
                maxItemStats.Add(weapon.ToString() + "True[ARCONCRIT]", -1);
                maxItemStats.Add(weapon.ToString() + "True[MAXARCPOWER]", -1);
            }

            foreach (ItemType weapon in twoHandRangeWeapons)
            {
                maxItemStats.Add(weapon.ToString() + "True[DEX]", 350);
                maxItemStats.Add(weapon.ToString() + "True[INT]", 350);
                maxItemStats.Add(weapon.ToString() + "True[STR]", 350);
                maxItemStats.Add(weapon.ToString() + "True[VIT]", 350);
                maxItemStats.Add(weapon.ToString() + "True[AS%]", 11);
                maxItemStats.Add(weapon.ToString() + "True[CRIT%]", -1);
                maxItemStats.Add(weapon.ToString() + "True[CRITDMG%]", 100);
                maxItemStats.Add(weapon.ToString() + "True[MAXDMG]", 411);
                maxItemStats.Add(weapon.ToString() + "True[MINDMG]", 316);
                maxItemStats.Add(weapon.ToString() + "True[BLOCK%]", -1);
                maxItemStats.Add(weapon.ToString() + "True[ARMORBONUS]", -1);
                maxItemStats.Add(weapon.ToString() + "True[THORNS]", -1);
                maxItemStats.Add(weapon.ToString() + "True[RESARCAN]", -1);
                maxItemStats.Add(weapon.ToString() + "True[RESCOLD]", -1);
                maxItemStats.Add(weapon.ToString() + "True[RESFIRE]", -1);
                maxItemStats.Add(weapon.ToString() + "True[RESHOLY]", -1);
                maxItemStats.Add(weapon.ToString() + "True[RESLIGHTNING]", -1);
                maxItemStats.Add(weapon.ToString() + "True[RESPHYSICAL]", -1);
                maxItemStats.Add(weapon.ToString() + "True[RESPOISON]", -1);
                maxItemStats.Add(weapon.ToString() + "True[ALLRES]", -1);
                maxItemStats.Add(weapon.ToString() + "True[GLOBEBONUS]", -1);
                maxItemStats.Add(weapon.ToString() + "True[LIFE%]", -1);
                maxItemStats.Add(weapon.ToString() + "True[LOH]", 959);
                maxItemStats.Add(weapon.ToString() + "True[REGEN]", -1);
                maxItemStats.Add(weapon.ToString() + "True[LS%]", 0.03);
                maxItemStats.Add(weapon.ToString() + "True[GF%]", -1);
                maxItemStats.Add(weapon.ToString() + "True[MF%]", -1);
                maxItemStats.Add(weapon.ToString() + "True[MS%]", -1);
                maxItemStats.Add(weapon.ToString() + "True[PICKRAD]", -1);
                maxItemStats.Add(weapon.ToString() + "True[SOCKETS]", 1);
                maxItemStats.Add(weapon.ToString() + "True[MAXFURY]", -1);
                maxItemStats.Add(weapon.ToString() + "True[HATREDREG]", -1);
                maxItemStats.Add(weapon.ToString() + "True[MAXDISCIP]", -1);
                maxItemStats.Add(weapon.ToString() + "True[HEALTHSPIRIT]", -1);
                maxItemStats.Add(weapon.ToString() + "True[SPIRITREG]", -1);
                maxItemStats.Add(weapon.ToString() + "True[MANAREG]", -1);
                maxItemStats.Add(weapon.ToString() + "True[MAXMANA]", -1);
                maxItemStats.Add(weapon.ToString() + "True[ARCONCRIT]", -1);
                maxItemStats.Add(weapon.ToString() + "True[MAXARCPOWER]", -1);
            }
        }

    }
}
